      function nfac(n0)
c
c $$$$$$ calls only library routines $$$$$$
c
c  nfac returns the largest integer le n0 which will be acceptable to
c  singleton's fft routine (1966 version).  see the comments at the
c  start of fft for details
c   programmed on 28 aug 1979 by ray buland
c
      dimension npr(9),ipr(9)
      data npr/2,3,5,7,11,13,17,19,23/
      n = iabs(n0)
      if(n.le.1) go to 13
c  initialize the prime factor search
 4    k = n
      nn = 0
      do 5 i=1,9
 5    ipr(i) = 0
c  extract all prime factors up to 23
      do 1 i=1,9
 3    l = k/npr(i)
      if(l*npr(i)-k.ne.0) go to 1
      k = l
      nn = nn + 1
      ipr(i) = mod(ipr(i)+1,2)
      if(k-1) 2,2,3
 1    continue
c  fall through if the largest prime factor is greater than 23
 6    n = n - 1
      go to 4
c  try again if more than 208 prime factors have been found
 2    if(nn.ge.209) go to 6
      k = 1
c  check the square free portion
      do 7 i=1,9
      if(ipr(i).gt.0) k = k*npr(i)
 7    continue
c  the product of the square free factors must by less than 211
      if(k.gt.210) go to 6
 13   nfac = n
      return
      end

